from abc import ABC, abstractmethod
from typing import Optional

from cpl_query.extension import List

from bot_data.model.known_user import KnownUser


class KnownUserRepositoryABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    def get_users(self) -> List[KnownUser]: pass
    
    @abstractmethod
    def get_user_by_id(self, id: int) -> KnownUser: pass
    
    @abstractmethod
    def get_user_by_discord_id(self, discord_id: int) -> KnownUser: pass
    
    @abstractmethod
    def find_user_by_discord_id(self, discord_id: int) -> Optional[KnownUser]: pass
    
    @abstractmethod
    def add_user(self, known_user: KnownUser): pass
    
    @abstractmethod
    def delete_user(self, known_user: KnownUser): pass
